#include "Calculatrice.hh"
//---------------------------------------------------------------------------------//

				//CLASSE CALCULATRICE//

//---------------------------------------------------------------------------------//
Calculatrice::Calculatrice():Gtk::Dialog(){
	//affichage dans la console
	std::cout << "constructeur particulier de calcul\n";
	
	//On crée la fenetre de dialogue
	xml = Gnome::Glade::Xml::create("Interface.glade");

	xml->get_widget("Calculette",fenetre);
	
	//On fait appel au méthode d'initialisation
	init_action();
	init_nb();
	init_math();
	init_carac();

	fenetre->show_all();
}

//----------------------- Méthode init_action --------------------//

//---------------------------------------------------------------//
//Initialisation de la liaison des boutons aux variables...
//Puis les variables aux methodes
//--------------------------------------------------------------//

void Calculatrice::init_action(){

	xml->get_widget("closebutton1",m_quitter);
	xml->get_widget("ecran", ecran);
	xml->get_widget("entree", entree);

	xml->get_widget("enter", m_enter);
	xml->get_widget("eval", m_egal);
	xml->get_widget("clear", m_clear);
	xml->get_widget("esc", m_esc);
	xml->get_widget("drop", m_drop);
	xml->get_widget("swap", m_swap);
	xml->get_widget("roll", m_roll);
	xml->get_widget("undo", m_undo);
	xml->get_widget("redo", m_redo);

	xml->get_widget("about", m_about);

	m_quitter->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::close));

	m_enter->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::saisie));
	m_clear->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::clear));
	m_egal->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::resultat));
	m_esc->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::effacer_saisie));
	m_drop->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_drop));
	m_swap->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_swap));
	m_roll->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_roll));
	m_undo->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_undo));
	m_redo->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_redo));

	m_about->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_about));
}

//----------------------- Méthode init_nb -----------------------//

//---------------------------------------------------------------//
//Initialisation de la liaison des boutons aux variables...
//Puis les variables aux methodes
//--------------------------------------------------------------//

void Calculatrice::init_nb(){
	xml->get_widget("nb0", nb0);	
	xml->get_widget("nb1", nb1);
	xml->get_widget("nb2", nb2);
	xml->get_widget("nb3", nb3);
	xml->get_widget("nb4", nb4);
	xml->get_widget("nb5", nb5);
	xml->get_widget("nb6", nb6);
	xml->get_widget("nb7", nb7);
	xml->get_widget("nb8", nb8);
	xml->get_widget("nb9", nb9);
	xml->get_widget("pi", Pi);

	nb0->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb0));
	nb1->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb1));
        nb2->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb2));
        nb3->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb3));
        nb4->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb4));
	nb5->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb5));
        nb6->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb6));
        nb7->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb7));
        nb8->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb8));
        nb9->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_nb9));
        Pi->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_Pi));
}

//----------------------- Méthode init_carac --------------------//

//---------------------------------------------------------------//
//Initialisation de la liaison des boutons aux variables...
//Puis les variables aux methodes
//--------------------------------------------------------------//

void Calculatrice::init_carac(){

	xml->get_widget(">>", m_guillemet_droit);
	xml->get_widget("<<", m_guillemet_gauche);
	xml->get_widget("evaluation", m_eval);
	xml->get_widget("space", m_espace);
	xml->get_widget("plot", m_plot);
	xml->get_widget("slot", m_slot);
	xml->get_widget("sep", m_sep);

	m_guillemet_droit->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_guillemet_droit));
	m_guillemet_gauche->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_guillemet_gauche));
	m_eval->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_eval));
	m_espace->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_espace));
	m_plot->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_plot));
	m_slot->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_slot));
	m_sep->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_sep));

	xml->get_widget("a", a);
	xml->get_widget("b", b);
	xml->get_widget("c", c);
	xml->get_widget("d", d);
	xml->get_widget("e", e);
	xml->get_widget("f", f);
	xml->get_widget("g", g);
	xml->get_widget("h", h);
	xml->get_widget("i", i);
	xml->get_widget("j", j);
	xml->get_widget("k", k);
	xml->get_widget("l", l);
	xml->get_widget("m", m);
	xml->get_widget("n", n);
	xml->get_widget("o", o);
	xml->get_widget("p", p);
	xml->get_widget("q", q);
	xml->get_widget("r", r);
	xml->get_widget("s", s);
	xml->get_widget("t", t);
	xml->get_widget("u", u);
	xml->get_widget("v", v);
	xml->get_widget("w", w);
	xml->get_widget("x", x);
	xml->get_widget("y", y);
	xml->get_widget("z", z);

	a->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_a));
	b->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_b));
	c->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_c));
	d->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_d));
	e->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_e));
	f->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_f));
	g->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_g));
	h->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_h));
	i->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_i));
	j->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_j));
	k->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_k));
	l->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_l));
	m->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_m));
	n->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_n));
	o->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_o));
	p->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_p));
	q->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_q));
	r->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_r));
	s->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_s));
	t->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_t));
	u->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_u));
	v->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_v));
	w->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_w));
	x->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_x));
	y->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_y));
	z->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_z));
}

//----------------------- Méthode init_math ---------------------//

//---------------------------------------------------------------//
//Initialisation de la liaison des boutons aux variables...
//Puis les variables aux methodes
//--------------------------------------------------------------//

void Calculatrice::init_math(){

	xml->get_widget("add", m_plus);
	xml->get_widget("sous", m_minus);
	xml->get_widget("mult", m_mult);
	xml->get_widget("div", m_div);

	xml->get_widget("carre", m_carre);
	xml->get_widget("racine", m_racine);
	xml->get_widget("puiss", m_puiss);
	xml->get_widget("exp", m_exp);
	xml->get_widget("log", m_log);
	xml->get_widget("inv", m_inv);

	xml->get_widget("chs", m_chs);

	xml->get_widget("sin", m_sin);
	xml->get_widget("cos", m_cos);
	xml->get_widget("tan", m_tan);
	xml->get_widget("asin", m_asin);
	xml->get_widget("acos", m_acos);
	xml->get_widget("atan", m_atan);

	m_plus->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_button_plus));
        m_minus->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_button_minus));
        m_mult->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_button_mult));
        m_div->signal_clicked().connect(sigc::mem_fun(*this, &Calculatrice::on_button_div));

	m_carre->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_carre));
	m_racine->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_racine));
	m_puiss->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_puiss));
	m_exp->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_exp));
	m_log->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_log));
	m_inv->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_inv));

	m_chs->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_chs));

	m_sin->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_sin));
	m_cos->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_cos));
	m_tan->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_tan));
	m_asin->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_asin));
	m_acos->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_acos));
	m_atan->signal_clicked().connect(sigc::mem_fun(this, &Calculatrice::on_atan));
}

//-------------------- Méthode getCalculatrice ------------------//

//---------------------------------------------------------------//
//Retourne un pointeur sur l'instanciation de cet classe
//--------------------------------------------------------------//

Gtk::Dialog& Calculatrice::getCalculatrice(){
	return *fenetre;
}

//------------------------- Méthode close -----------------------//

//---------------------------------------------------------------//
//Méthode permettant de fermer la boite de dialogue
//--------------------------------------------------------------//

void Calculatrice::close(){
	//On affiche dans la console
	std::cout << "Fermeture\n";
	//On détruit grace au destructeur
	delete this;
	//On quitte la fenetre Gtk
	Gtk::Main::quit();
}

//------------------------- Méthode About -----------------------//

//---------------------------------------------------------------//
//Affiche la boite de dialogue A propos de
//--------------------------------------------------------------//
void Calculatrice::on_about(){
	About propos;
	//on lance l'interface et ses méthodes
	propos.show_all();
}

//--------------------- Méthode effacer_saisie ------------------//

//---------------------------------------------------------------//
//Méthode permettant d'effacer un caractere à la chaine dans 
//entree
//--------------------------------------------------------------//

void Calculatrice::effacer_saisie(){
	std::string var;
	//On initialise la variable à la valeur d'entree
	var=entree->get_text();
	//On initialise taille à la taille du string -1 pour effacer le dernier caractere
	int taille=(int)var.size()-1;
	//On initialise l'entree
	entree->set_text(boost::lexical_cast<std::string>(""));
	for(int i=0;i<taille;i++){
		//On réaffiche la valeur moins le dernier caractere
		entree->set_text(entree->get_text() + boost::lexical_cast<std::string>(var[i]));
	}
}

//------------------------- Méthode clear -----------------------//

//---------------------------------------------------------------//
//Méthode permettant de rafraichir l'ecran et l'entree
//Et d'initialiser la pile
//--------------------------------------------------------------//

void Calculatrice::clear(){
	//on rafraichit l'entree
	entree->set_text(boost::lexical_cast<std::string>(""));
	//on rafraichit l'ecran
	ecran->set_text(boost::lexical_cast<std::string>(""));
	//Tant que la pile n'est pas vide on dépile
	Calcul.vider_pile();
}

//------------------------ Méthode resultat ---------------------//

//---------------------------------------------------------------//
//Méthode permettant d'afficher le égal et de rafraichir l'ecran
//afin d'afficher les resultat tout comme le bouton enter
//--------------------------------------------------------------//

void Calculatrice::resultat(){
	//on affiche dans entree '='
	entree->set_text("=");
	//on rafraichit l'écran de facon à afficher le '='
	rafraichissement("=");
}

//------------------------ Méthode saisie -----------------------//

//---------------------------------------------------------------//
//Méthode permettant de supprimer le sommet de la pile
//--------------------------------------------------------------//

void Calculatrice::saisie(){
	string chn=boost::lexical_cast<std::string>(entree->get_text());
	//si l'entree n'est pas vide
	if(chn!=""){
		Calcul.is_float_empiler(chn);
	}
	//on rafraichit l'entree
	entree->set_text(boost::lexical_cast<std::string>(""));
	//on rafraichit l'écran de facon à afficher les nouvelles valeurs
	rafraichissement();
	
}

//-------------------- Méthode rafraichissement -----------------//

//---------------------------------------------------------------//
//Méthode permettant de rafraichir l'ecran avec les nouvelles
//valeurs, ainsi que l'opérateur de l'opération effectué...
//~~~~~~~~~~~~~~~~> Méthode surchargé
//--------------------------------------------------------------//

void Calculatrice::rafraichissement(std::string nom){

	int i=0;
	//On inialise variable à la taille de la pile
	int taille=Calcul.get_taille_pile();
	//si l'entree n'est pas vide
	if(taille==0){
		//On initialise l'ecran à vide
		ecran->set_text("");
		//On rempli l'ecran de retour chariot car il ne contient que l'operateur
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(nom));
	
	}else{
		//sinon si la taille est supérieur à 0
		if(taille>0){
			//On initialise l'ecran a vide
			ecran->set_text("");
			//On vérifie si la taille de la pile est inferieur au nombre de ligne
			if(taille<8){
				//Si c'est le cas
				//On crée un tableau de Nombre
				Nombre affiche[taille];
				//Tant que l'on a pas atteint l'endroit ou on pourra commencer a afficher
				while(i<(8-taille-1)){
					//On ajoute des retour chariot
					ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
					i++;
				}
				//Puis On dépile les élements de la pile que l'on stock dans un tableau
				for(i=0;i<taille;i++){
					affiche[i]=Calcul.depiler_Nombre();
				}
				//Enfin on Affiche les valeurs et on rempile dans le bon ordre
				for(i=taille-1;i>=0;i--){
					ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(affiche[i].getFloat()));
					ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
					Calcul.empiler_Nombre(affiche[i]);
				}
				//Ensuite on affiche l'opérateur	
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(nom));
			}else{
				//Sinon c'est que la pile est supérieur à la taille de l'ecran
				//On initialise donc la taille à 8
				taille=8;
				//On crée un tableau de taille-1
				Nombre affiche[taille-1];
				//Puis On dépile les élements de la pile que l'on stock dans un tableau
				for(i=0;i<taille;i++){
					affiche[i]=Calcul.depiler_Nombre();;
				}
				//Enfin on Affiche les valeurs et on rempile dans le bon ordre moins l'opérateur 
				//à ajouter ( d'ou le moins 2 à l'initialisation de i)
				for(i=taille-2;i>=0;i--){
					ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(affiche[i].getFloat()));
					ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
					Calcul.empiler_Nombre(affiche[i]);
				}
				//Ensuite on affiche l'opérateur
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(nom));	
			}
		}else{
			//Sinon il n'y a pas de donnée donc ... erreur...
			ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("il n'y a pas de donnée \n"));
		}
	}
}

//-------------------- Méthode rafraichissement -----------------//

//---------------------------------------------------------------//
//Méthode permettant de rafraichir l'ecran avec les nouvelles
//valeurs...
//~~~~~~~~~~~~~~~~> Méthode surchargé
//--------------------------------------------------------------//

void Calculatrice::rafraichissement(){

	int i=0;
	//On inialise variable à la taille de la pile
	int taille=Calcul.get_taille_pile();
	//si l'entree n'est pas vide
	if(taille!=0){
		//On initialise l'ecran à vide
		ecran->set_text("");
		//On vérifie si la taille de la pile est inferieur au nombre de lign
		if(taille<8){
			//Si c'est le cas
			//On crée un tableau de Nombre
			Nombre affiche[taille];
			//Tant que l'on a pas atteint l'endroit ou on pourra commencer a afficher	
			while(i<(8-taille)){
				//On ajoute des retour chariot
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
				i++;
			}
			//Puis On dépile les élements de la pile que l'on stock dans un tableau
			for(i=0;i<taille;i++){
				affiche[i]=Calcul.depiler_Nombre();
			}
			//Enfin on Affiche les valeurs et on rempile dans le bon ordre
			for(i=taille-1;i>=0;i--){
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(affiche[i].getFloat()));
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
				Calcul.empiler_Nombre(affiche[i]);
			}	
	
		}else{
			//Sinon c'est que la pile est supérieur à la taille de l'ecran
			//On initialise donc la taille à 8
			taille=8;
			//On crée un tableau de taille-1
			Nombre affiche[taille-1];
			//Puis On dépile les élements de la pile que l'on stock dans un tableau
			for(i=0;i<taille;i++){
				affiche[i]=Calcul.depiler_Nombre();
			}
			//Enfin on Affiche les valeurs et on rempile dans le bon ordre
			for(i=taille-1;i>=0;i--){
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>(affiche[i].getFloat()));
				ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("\n"));
				Calcul.empiler_Nombre(affiche[i]);
			}	
		}
	}else{
		//Sinon il n'y a pas de donnée donc ... erreur...
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("il n'y a pas de donnée \n"));
	}
}

//------------------------ Méthode DROP -------------------------//

//---------------------------------------------------------------//
//Méthode permettant de supprimer le sommet de la pile
//--------------------------------------------------------------//

void Calculatrice::on_drop(){
	if(Calcul.drop()){
		//on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement("DROP");
	}
}

//------------------------ Méthode SWAP -------------------------//

//---------------------------------------------------------------//
//Méthode permettant de permuter 2 éléments de la pile
//--------------------------------------------------------------//

void Calculatrice::on_swap(){
	//on rafraichit l'écran de facon à afficher l'opération à effectuer
	if(Calcul.swap()){
		rafraichissement("SWAP");
	}
}

//------------------------ Méthode ROLL -------------------------//

//---------------------------------------------------------------//
//Méthode permettant d'effectuer une rotation entre n élément de
//la pile. Le nombre d'élement de la rotation étant en sommet de
//la pile...
//--------------------------------------------------------------//

void Calculatrice::on_roll(){
	//on rafraichit l'écran de facon à afficher l'opération à effectuer
	if(Calcul.roll()){
		rafraichissement("ROLL");
	}
}

//------------------------ Méthode UNDO -------------------------//

//---------------------------------------------------------------//
//Méthode permettant d'annuler la dernière opération
//--------------------------------------------------------------//

void Calculatrice::on_undo(){
	if(Calcul.undo()){
		//on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement("UNDO");
	}
}

//------------------------ Méthode REDO -------------------------//

//---------------------------------------------------------------//
//Méthode permettant de réappliquer une meme opération
//--------------------------------------------------------------//

void Calculatrice::on_redo(){
	if(Calcul.redo()){
		//on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement("REDO");
	}
}

//------------- Méthode des fonction arithmétique ---------------//

//---------------------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche le résultat
//après avoir effectué l'appel à la méthode de calcul...
//--------------------------------------------------------------//

void Calculatrice::on_button_plus(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"+");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.addition());
	}
}

void Calculatrice::on_button_minus(){
	
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"-");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.soustraction());
	}
}

void Calculatrice::on_button_mult(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"*");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.mult());
	}
}

void Calculatrice::on_button_div(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"/");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.div());
	}
}

//--------------- Méthode des fonction puissance ----------------//

//---------------------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche le résultat
//après avoir effectué l'appel à la méthode de calcul...
//--------------------------------------------------------------//

void Calculatrice::on_carre(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"x^2");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.carre());
	}
}

void Calculatrice::on_racine(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"Vx");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.racine());
	}
}

void Calculatrice::on_puiss(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"x^y");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.puiss());
	}
}

void Calculatrice::on_exp(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"e^x");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.exp());

	}
}

void Calculatrice::on_log(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"lnx");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.log());
	}
}

void Calculatrice::on_inv(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"1/x");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.inv());
	}
}

void Calculatrice::on_chs(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"-x");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.chs());
	}
}
	
//----------- Méthode des fonction trigonométrique --------------//

//---------------------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche le résultat
//après avoir effectué l'appel à la méthode de calcul...
//--------------------------------------------------------------//

void Calculatrice::on_sin(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"sin");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.sin());
	}
}

void Calculatrice::on_cos(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"cos");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.cos());
	}
}

void Calculatrice::on_tan(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"tan");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.tan());
	}
}

void Calculatrice::on_asin(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"asin");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.asin());
	}
}

void Calculatrice::on_acos(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"acos");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.acos());
	}
}

void Calculatrice::on_atan(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	//on vérifie si il s'agit d'une expression
	if(chn[0]=='<' and chn[1]=='<'){
		//si c'est le cas on affiche dans la zone de saisie
		entree->set_text(entree->get_text()+"atan");
	}else{
		//sinon on effectue le traitement et on rafraichit l'écran de facon à afficher l'opération à effectuer
		rafraichissement(Calcul.atan());
	}
}


//------------- Méthode des Expressions ---------------//

//----------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche
//dans l'écran la valeur du bouton pressé...
//---------------------------------------------------//

void Calculatrice::on_guillemet_droit(){
		entree->set_text(entree->get_text()+">>");
}

void Calculatrice::on_guillemet_gauche(){
		entree->set_text(entree->get_text()+"<<");
}

void Calculatrice::on_espace(){
		entree->set_text(entree->get_text()+" ");
}

void Calculatrice::on_sep(){
		entree->set_text(entree->get_text()+"'");
}

//------------- Méthode de l'évaluation ---------------//
//-----------------------------------------------------//
//Elle prend la valeur de ce qu'il y a dans l'entree
//Elle traite l'information en empilant les float et
//dés qu'elle rencontre une valeur différentes et 
//correspondante à une fonction, elle l'appelle...
//----------------------------------------------------//
void Calculatrice::on_eval(){
	//initialisation de chn à la valeur de la zone de saisie
	string chn=entree->get_text();
	int taille=chn.size();
	string chn2;

	//on rafraichit l'écran
	entree->set_text("");	

	if(chn[0]=='<' and chn[1]=='<' and chn[taille-2]=='>' and chn[taille-1]=='>' ){
		//initialisation des séparateur
		boost::char_separator<char> sep("< > ");
		//initialisation du tokenizer
		boost::tokenizer< boost::char_separator<char> > tok(chn,sep);
		boost::tokenizer< boost::char_separator<char> >::iterator itr, itr_end;
		//creation de la fin et du debut pour la boucle car sinon on ne peut pas faire d'itération
		itr = tok.begin();
		itr_end = tok.end();
		//on effectue la recherche sur la chaine de caractere
		for(;itr!=itr_end;++itr){
			//on initialise chn2 a la valeur de itr
			chn2=boost::lexical_cast<std::string>(*itr);

			Calcul.is_float_empiler(chn2);

			//si il ne s'agit pas d'un float on vérifie si il s'agit d'une fonction

			//fonction arithmétique
			if(chn2=="+")on_button_plus();
			if(chn2=="-")on_button_minus();
			if(chn2=="*")on_button_mult();
			if(chn2=="/")on_button_div();

			//fonction puissance
			if(chn2=="-x")on_chs();
			if(chn2=="x^y")on_puiss();
			if(chn2=="1/x")on_inv();
			if(chn2=="lnx")on_log();
			if(chn2=="e^x")on_exp();
			if(chn2=="Vx")on_racine();
			if(chn2=="x^2")on_carre();

			//fonction trigonométrique
			if(chn2=="sin")on_sin();
			if(chn2=="cos")on_cos();
			if(chn2=="tan")on_tan();
			if(chn2=="asin")on_asin();
			if(chn2=="acos")on_acos();
			if(chn2=="atan")on_atan();

			//Si il ne s'agit pas d'une fonction on vérifie si il s'agit d'une variable
			Calcul.is_Variable_empiler(chn2);
		}
	}else{
		//sinon il ne s'agit pas d'une expression valide
		ecran->set_text(ecran->get_text() + boost::lexical_cast<std::string>("ceci n'est pas un expression \n"));
	}
}
//---------- Méthode de creation de variable ----------//
//-----------------------------------------------------//
//Méthode permettant de creer une variable 
//----------------------------------------------------//
void Calculatrice::on_slot(){
	string chn=entree->get_text();
	string chn2;
	//on rafraichit l'entree
	entree->set_text(boost::lexical_cast<std::string>(""));
	if(chn[0]=='\'' and chn[chn.size()-1]=='\''){
		boost::char_separator<char> sep("' ");
		//initialisation du tokenizer
		boost::tokenizer< boost::char_separator<char> > tok(chn,sep);
		boost::tokenizer< boost::char_separator<char> >::iterator itr, itr_end;
		//creation de la fin et du debut pour la boucle car sinon on ne peut pas faire d'itération
		itr = tok.begin();
		itr_end = tok.end();
		//on effectue la recherche sur la chaine de caractere
		for(;itr!=itr_end;++itr){
			//on initialise chn2 a la valeur de itr
			chn2=boost::lexical_cast<std::string>(*itr);
			if(chn[0]>='a' and chn[0]<='z'){
				Calcul.set_variable(chn2);
			}else{
				Calcul.is_float_empiler(chn2);
			}
		}
	}
}

//---------- Méthode du tracage de la courbe ----------//
//-----------------------------------------------------//
//Méthode permettant de tracer une courbe selon une 
//expression donnée
//----------------------------------------------------//
void Calculatrice::on_plot(){

}

//------------- Méthode des numérique ----------------//

//----------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche
//dans l'écran la valeur du bouton pressé...
//---------------------------------------------------//

void Calculatrice::on_nb0(){
	entree->set_text(entree->get_text()+"0");
}

void Calculatrice::on_nb1(){
	entree->set_text(entree->get_text()+"1");
}

void Calculatrice::on_nb2(){
	entree->set_text(entree->get_text()+"2");
}

void Calculatrice::on_nb3(){
	entree->set_text(entree->get_text()+"3");
}

void Calculatrice::on_nb4(){
	entree->set_text(entree->get_text()+"4");;
}

void Calculatrice::on_nb5(){
	entree->set_text(entree->get_text()+"5");
}

void Calculatrice::on_nb6(){
	entree->set_text(entree->get_text()+"6");
}

void Calculatrice::on_nb7(){
	entree->set_text(entree->get_text()+"7");
}

void Calculatrice::on_nb8(){
	entree->set_text(entree->get_text()+"8");
}

void Calculatrice::on_nb9(){
	entree->set_text(entree->get_text()+"9");
}

void Calculatrice::on_Pi(){
	entree->set_text(entree->get_text()+"3.14");
}

//------------- Méthode des alphabétique ------------//

//---------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche
//dans l'écran la valeur du bouton pressé...
//---------------------------------------------------//

void Calculatrice::on_a(){
	entree->set_text(entree->get_text()+"a");
}

void Calculatrice::on_b(){
	entree->set_text(entree->get_text()+"b");
}

void Calculatrice::on_c(){
	entree->set_text(entree->get_text()+"c");
}

void Calculatrice::on_d(){
	entree->set_text(entree->get_text()+"d");
}

void Calculatrice::on_e(){
	entree->set_text(entree->get_text()+"e");
}

void Calculatrice::on_f(){
	entree->set_text(entree->get_text()+"f");
}

void Calculatrice::on_g(){
	entree->set_text(entree->get_text()+"g");
}

void Calculatrice::on_h(){
	entree->set_text(entree->get_text()+"h");
}

void Calculatrice::on_i(){
	entree->set_text(entree->get_text()+"i");
}

void Calculatrice::on_j(){
	entree->set_text(entree->get_text()+"j");
}

void Calculatrice::on_k(){
	entree->set_text(entree->get_text()+"k");
}

void Calculatrice::on_l(){
	entree->set_text(entree->get_text()+"l");
}

void Calculatrice::on_m(){
	entree->set_text(entree->get_text()+"m");
}

void Calculatrice::on_n(){
	entree->set_text(entree->get_text()+"n");
}

void Calculatrice::on_o(){
	entree->set_text(entree->get_text()+"o");
}

void Calculatrice::on_p(){
	entree->set_text(entree->get_text()+"p");
}

void Calculatrice::on_q(){
	entree->set_text(entree->get_text()+"q");
}

void Calculatrice::on_r(){
	entree->set_text(entree->get_text()+"r");
}

void Calculatrice::on_s(){
	entree->set_text(entree->get_text()+"s");
}

void Calculatrice::on_t(){
	entree->set_text(entree->get_text()+"t");
}

void Calculatrice::on_u(){
	entree->set_text(entree->get_text()+"u");
}

void Calculatrice::on_v(){
	entree->set_text(entree->get_text()+"v");
}

void Calculatrice::on_w(){
	entree->set_text(entree->get_text()+"w");
}

void Calculatrice::on_x(){
	entree->set_text(entree->get_text()+"x");
}

void Calculatrice::on_y(){
	entree->set_text(entree->get_text()+"y");
}

void Calculatrice::on_z(){
	entree->set_text(entree->get_text()+"z");
}
