#include "Moteur.hh"
/*------------- constructeur ------------*/
Moteur::Moteur(){

}
/*------------- destructeur ------------*/
Moteur::~Moteur(){

}
//----------------------- Méthode empiler_Nombre --------------//

//---------------------------------------------------------------//
//Permet d'empiler un Nombre dans la stack en fonction de la chaine
//passé en parametre que l'on cast en float
//--------------------------------------------------------------//
void Moteur::empiler_Nombre(string var){
	first.push(Nombre(boost::lexical_cast<float>(var)));
}

//----------------------- Méthode empiler_Nombre --------------//

//---------------------------------------------------------------//
//Surcharge de la méthode ci dessus en envoyant cette fois un
//Nombre que l'on empile directement
//--------------------------------------------------------------//
void Moteur::empiler_Nombre(Nombre var){
	first.push(var);
}

//----------------------- Méthode dépiler_Nombre ----------------//

//---------------------------------------------------------------//
//Méthode permettant de récupérer la valeur au sommet de pile et
//de dépiler la variable
//--------------------------------------------------------------//
Nombre Moteur::depiler_Nombre(){
	Nombre a=(Nombre)first.top();
	first.pop();
	return a;
}

//----------------------- Méthode get_taille_pile --------------//

//---------------------------------------------------------------//
//renvoit la taille de la pile
//--------------------------------------------------------------//
int Moteur::get_taille_pile(){
	return first.size();
}

//----------------------- Méthode vider_pile --------------------//

//---------------------------------------------------------------//
//Permet d'initialiser la pile à vide
//--------------------------------------------------------------//
void Moteur::vider_pile(){
	while(!first.empty()){
		first.pop();
	}
}

//----------------------- Méthode set_variable ------------------//

//---------------------------------------------------------------//
//Si je ne trouve pas de variable contenant l'index passé en 
//parametre c'est qu'il n'existe pas d'index de ce type
//donc je dépile la valeur en sommet de pile et je crée une variable
//d'index chn et de valeur a
//--------------------------------------------------------------//
void Moteur::set_variable(string chn){
	if(liste.find(chn)==liste.end()){
		Nombre a=(Nombre)first.top();
		first.pop();
		liste[chn]=a;
	}
}
//----------------------- Méthode get_variable ------------------//

//---------------------------------------------------------------//
//On retourne la valeur du Nombre de l'index passé en paramètre
//en vérifiant qu'il existe
//--------------------------------------------------------------//
Nombre Moteur::get_variable(string chn){
	Nombre a;
	if(liste.find(chn)!=liste.end()){
		a=liste[chn];
	}
	return a;
}
//-------------------- Méthode is_Variable_empiler --------------//

//---------------------------------------------------------------//
//On vérifie si la chaine passé en parametre est une variable
//et si c'est le cas on empile sa valeur
//--------------------------------------------------------------//
void Moteur::is_Variable_empiler(string chn){
	if(liste.find(chn)!=liste.end()){
		first.push(liste[chn]);
	}
}

//----------------------- Méthode is_float_empiler --------------//

//---------------------------------------------------------------//
//On vérifie si la chaine passé en parametre peut etre un float
//et si c'est le cas on l'empile
//--------------------------------------------------------------//
void Moteur::is_float_empiler(string chn){
	float nb;
	std::istringstream iss(chn);
	//utilisation de la bibliotheque std pour vérifier si il s'agit d'un float
	if(( iss >> nb ) && ( iss.eof() )){
		//si c'est le cas on l'empile après l'avoir caster en Nombre
		nb=boost::lexical_cast<float>(chn);
		first.push(Nombre(nb));
	}
}

//------------------------ Méthode DROP -------------------------//

//---------------------------------------------------------------//
//Méthode permettant de supprimer le sommet de la pile
//--------------------------------------------------------------//
int Moteur::drop(){
	//on vérifie si la pile est vide
	if(!first.empty()){
		//on dépile afin de supprimer le sommet de pile
		first.pop();
		return 1;
	}else{
		return 0;
	}
}

//------------------------ Méthode SWAP -------------------------//

//---------------------------------------------------------------//
//Méthode permettant de permuter 2 éléments de la pile
//--------------------------------------------------------------//
int Moteur::swap(){
	//on vérifie si la pile est vide
	if(!first.empty()){
		Nombre a,b;
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		//on dépile que l'on cast pour obtenir un type Nombre
		b=(Nombre)first.top();
		first.pop();
		//et on empile dans l'ordre inverse de facon à permuter les élements de la pile
		first.push(a);
		first.push(b);
		return 1;
	}else{
		return 0;
	}
}

//------------------------ Méthode ROLL -------------------------//

//---------------------------------------------------------------//
//Méthode permettant d'effectuer une rotation entre n élément de
//la pile. Le nombre d'élement de la rotation étant en sommet de
//la pile...
//--------------------------------------------------------------//
int Moteur::roll(){
	Nombre a;
	//on vérifie si la pile est vide
	if(!first.empty()){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		//on initialise taille au nombre de rotation à effectuer
		int taille = (int)a.getFloat();
		//on initialise taille_p à la taille de la pile
		int taille_pile=first.size();
		//on vérifie si le nombre de rotation à effectuer n'est pas supérieur au nombre d'élement de la pile
		if(taille_pile>=taille){
			//on crée un tableau de nombre pour récupérer les valeurs de la pile
			Nombre tab[taille-1];
			int i;
			//on boucle pour dépiler et administrer la valeur de la pile au tableau
			for(i=0;i<=taille-1;i++){
				//on dépile que l'on cast pour obtenir un type Nombre
				tab[i]=(Nombre)first.top();
				first.pop();
			}
			//on empile le premier élement du tableau à la fin de la pile pour la rotation
			first.push(tab[0]);
			//on initialise alors i à la taille-1 (nombre deja empiler) 
			i=taille-1;
			//on boucle pour réempiler les valeurs
			while(i!=0){
				//et on rempile par rapport au tableau créé
				first.push(tab[i]);
				i--;
			}
			return 1;
		}else{
			return 0;
		}
	}else{
		return 0;
	}
}

//------------------------ Méthode UNDO -------------------------//

//---------------------------------------------------------------//
//Méthode permettant d'annuler la dernière opération
//--------------------------------------------------------------//
int Moteur::undo(){
	//on vérifie si la pile est vide
	if(!first.empty()){
		//on dépile afin d'annuler la dernière opération
		first.pop();
		return 1;
	}else{
		return 0;
	}
}

//------------------------ Méthode REDO -------------------------//

//---------------------------------------------------------------//
//Méthode permettant de réappliquer une meme opération
//--------------------------------------------------------------//
int Moteur::redo(){
	Nombre a;
	//on dépile que l'on cast pour obtenir un type Nombre
	a=(Nombre)first.top();
	first.pop();
	//Et on empile 2 fois afin de multiplier la dernière opération
	first.push(a);
	first.push(a);
	return 1;
}

//------------- Méthode des fonction arithmétique ---------------//

//---------------------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche le résultat
//après avoir effectué l'appel à la méthode de calcul...
//--------------------------------------------------------------//
string Moteur::addition(){
	Nombre a,b;
	string nom, nom2;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=2){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		//puis une deuxieme
		b=(Nombre)first.top();
		first.pop();
		//on cast la valeur en string pour la passer au rafraichissement afin qu'elle l'affiche
		nom=boost::lexical_cast<std::string>(a.getFloat());
		nom2=boost::lexical_cast<std::string>(b.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.addition(b);
		//on empile le résultat
		first.push(Nombre(a));
	}
	return (nom + " + " + nom2);
}

string Moteur::soustraction(){
	Nombre a,b;
	string nom, nom2;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=2){
		//on dépile une premiere valeur que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		//puis une deuxieme
		b=(Nombre)first.top();
		first.pop();
		//on cast la valeur en string pour la passer au rafraichissement afin qu'elle l'affiche
		nom=boost::lexical_cast<std::string>(a.getFloat());
		nom2=boost::lexical_cast<std::string>(b.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.soustraction(b);
		//on empile le résultat
		first.push(a);
	}
	return (nom + " - " + nom2);
}

string Moteur::mult(){
	Nombre a,b;
	string nom, nom2;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=2){
		//on dépile une premiere valeur que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		//puis une deuxieme
		b=(Nombre)first.top();
		first.pop();
		//on cast la valeur en string pour la passer au rafraichissement afin qu'elle l'affiche
		nom=boost::lexical_cast<std::string>(a.getFloat());
		nom2=boost::lexical_cast<std::string>(b.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.multiplication(b);
		//on empile le résultat
		first.push(a);
	}
	return (nom + " * " + nom2);
}

string Moteur::div(){
	Nombre a,b;
	string nom, nom2;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=2){
		//on dépile une premiere valeur que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		//puis une deuxieme
		b=(Nombre)first.top();
		first.pop();
		//on cast la valeur en string pour la passer au rafraichissement afin qu'elle l'affiche
		nom=boost::lexical_cast<std::string>(a.getFloat());
		nom2=boost::lexical_cast<std::string>(b.getFloat());
		//on vérifie que b est different de 0
		if(b.getFloat()!=0.0){
		//on appelle la méthode permettant le calcul
			a=a.division(b);
			//on empile le résultat
			first.push(a);;
		}
	}
	return (nom + " / " + nom2);
}

//--------------- Méthode des fonction puissance ----------------//

//---------------------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche le résultat
//après avoir effectué l'appel à la méthode de calcul...
//--------------------------------------------------------------//

string Moteur::carre(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.carre();
		//on empile le résultat
		first.push(a);
	}
	return ( chn + "^2");
}

string Moteur::racine(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.racine();
		//on empile le résultat
		first.push(a);
	}
	return ("√"+ chn );
}

string Moteur::puiss(){
	Nombre a,b;
	string nom,nom2;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=2){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		b=(Nombre)first.top();
		first.pop();
		nom=boost::lexical_cast<std::string>(a.getFloat());
		nom2=boost::lexical_cast<std::string>(b.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.puiss(b.getFloat());
		//on empile le résultat
		first.push(a);
	}
	return (nom + " ^ " + nom2);
}

string Moteur::exp(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.expo();
		//on empile le résultat
		first.push(a);
	}
	return ("e^" + chn);
}

string Moteur::log(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.logarithme();
		//on empile le résultat
		first.push(a);
	}
	return("ln" + chn);
}

string Moteur::inv(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.inverse();
		//on empile le résultat
		first.push(a);
	}
	return("1/" + chn);
}

string Moteur::chs(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.chn_signe();
		//on empile le résultat
		first.push(a);
	}
	return("-" + chn);
}

//----------- Méthode des fonction trigonométrique --------------//

//---------------------------------------------------------------//
//Quand l'utilisateur appuit sur un bouton on affiche le résultat
//après avoir effectué l'appel à la méthode de calcul...
//--------------------------------------------------------------//
string Moteur::sin(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.sinus();
		//on empile le résultat
		first.push(a);
	}
	return("sin" + chn);
}

string Moteur::cos(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.cosinus();
		//on empile le résultat
		first.push(a);
	}
	return("cos" + chn);
}

string Moteur::tan(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.tangente();
		//on empile le résultat
		first.push(a);
	}
	return("tan" + chn);
}

string Moteur::asin(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.asinus();
		//on empile le résultat
		first.push(a);
	}
	return("asin" + chn);
}

string Moteur::acos(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.acosinus();
		//on empile le résultat
		first.push(a);
	}
	return("acos" + chn);
}

string Moteur::atan(){
	Nombre a;
	string chn;
	// si la taille de la pile est supérieur ou egale à un
	if(first.size()>=1){
		//on dépile que l'on cast pour obtenir un type Nombre
		a=(Nombre)first.top();
		first.pop();
		chn=boost::lexical_cast<std::string>(a.getFloat());
		//on appelle la méthode permettant le calcul
		a=a.atangente();
		//on empile le résultat
		first.push(a);
	}
	return("atan" + chn);
}
