#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Client to share and get files via XMPP
# Copyright (C) 2010 Sébastien Dumont
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
clientedl is a client for the xmpp protocol.
It add a ressource to your jid which allow you to publish add share the files
you want to.
"""

# Import from the Standard Library
from optparse import OptionParser
from getpass import getpass

# Import from here
from shell import Shell
from commands import COMMANDS


def main():
    """client.py jabberid passwd
    """
    # The command line parser
    usage = '%prog [OPTIONS]'
    description = 'Client to get files via XMPP'
    version = 'v0.0'
    parser = OptionParser(usage, version=version, description=description)
    parser.add_option("-u", "--user", type="string", action="store",
                      dest="username", help="name of the user")
    parser.add_option("-p", "--password", type="string", action="store",
                      dest="userpasswd", help="password of the user")
    options, args = parser.parse_args()
    if options.username is None:
        options.username = raw_input("Jabberid is not defined. Enter it: ")
    if options.userpasswd is None:
        options.userpasswd = getpass("Password: ")
    # TODO connect to xmpp
    print 'DEBUG jabberid:"%s" password:"%s"' % (options.username,
                                                 options.userpasswd)
    Shell(COMMANDS).shell_loop()



if __name__ == "__main__":
    main()
