# -*- coding: utf-8 -*-
#
# Generic Shell
# Copyright (C) 2010 Sébastien Dumont <sdumont@masteri2l.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

##############################################################################
# Basic Exceptions
##############################################################################
##\exception CommandError
#\brief gestion des exception de type "erreur de commande"
class CommandError(Exception):
    def __str__(self):
        return 'Command Error'



##\exception CommandNotFoundError
#\brief gestion des exception de type "commande inconnue"
class CommandNotFoundError(CommandError):
    def __str__(self):
        return 'Command not found'



##\exception TooFewArgError
#\brief gestion des exception de type "pas assez d'arguments"
class TooFewArgError(CommandError):
    def __str__(self):
        return '%s: Too Few Arguments' % CommandError.__str__(self)



##\exception TooManyArgError
#\brief gestion des exception de type "trop d'arguments"
class TooManyArgError(CommandError):
    def __str__(self):
        return '%s: Too Many Arguments' % CommandError.__str__(self)



