package SmplSWT;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;

public class SmplWidgets {
	
	private Display display;
	private Shell shell;
	private Label label ;
	private Button button;
	private Text text ;
	private List list ;
	private Combo combo ;
	private Table table ;

	public SmplWidgets() {
		buildUI() ;
		addListeners() ;
		go() ;
	}
	
	private void buildUI() {
		display = new Display() ;
		shell = new Shell(display) ;
		shell.setText("Hello World Example") ;
		RowLayout rowLayout = new RowLayout(SWT.VERTICAL) ;
		shell.setLayout(rowLayout) ;
		
		label = new Label(shell, SWT.RIGHT) ;
		ImageData imageData = new ImageData("images/LoGhostInv150.png") ;
		Image image = new Image(null, imageData) ;
		label.setImage(image) ;
		
		button = new Button(shell, SWT.PUSH) ;
		button.setText("Cliquer ici") ;
		
		text = new Text(shell, SWT.MULTI) ;
		text.setText("LAME SOEUR") ;
		
		list = new List(shell, SWT.SINGLE) ;
		list.add("Greg") ;
		list.add("Ze Best") ;
		
		combo = new Combo(shell, SWT.SIMPLE) ;
		combo.add("TD-20") ;
		combo.add("VH-12") ;
		
		table = new Table(shell, SWT.SINGLE | SWT. BORDER | SWT.FULL_SELECTION) ;
		TableColumn column1 = new TableColumn(table, SWT.NULL) ;
		column1.setText("Name") ;
		TableColumn column2 = new TableColumn(table, SWT.NULL) ;
		column2.setText("Age") ;
		TableItem item1 = new TableItem(table , SWT.NULL) ;
		item1.setText(new String[] {"Roger", "18"}) ;
		TableItem item2 = new TableItem(table , SWT.NULL) ;
		item2.setText(new String[] {"Germaine", "50"}) ;
		column1.pack() ;
		column2.pack()  ;
		table.setHeaderVisible(true) ;
		
		shell.pack() ;
	}
	
	private void addListeners() {
		
		button.addSelectionListener(new SelectionAdapter(){
			public void widgetSelected(SelectionEvent evt){
				System.out.println("Hello World !!!");
				display.beep() ;
			}
		}) ;
		
		display.addListener(SWT.Dispose, new Listener(){

			public void handleEvent(Event arg0) {
				System.out.println("Dispose pour le display !");
				
			}
			
		}) ;
	}
	
	private void go() {
		shell.open() ;
		while(!shell.isDisposed()){
			if (! display.readAndDispatch()) display.sleep() ;
		}
		display.dispose() ;
	}
	
	public static void main(String[] args) {
		new SmplWidgets() ;
	}

}
