# -*- coding: utf-8 -*-
# class JabberBot
# overloads the Bot class and implements XMPP protocol
#
# author: Sergiu MIHAI
# 
# date: 24/11/2009



from bot import Bot
from twisted.words.protocols.jabber import client, jid
from twisted.words.xish import domish
from twisted.internet import reactor


class JabberBot():

    """
    JabberBot class.
    """

    xmlstream = None

    

    def __init__(self, id, password, host = None, port = 5222, **kwargs):
        self.jid = jid.JID(id)
        self.password = password
        self.host = self.jid.host
        if host:
            self.host = host
        self.port = port
        self.status = "chat"
        if kwargs.has_key('status') and kwargs['status']:
            self.status = kwargs['status']


    def authd(self, xmlstream):
        self.xmlstream = xmlstream
        self.set_status()
        # declenche function si il match l'expression xpath
        xmlstream.addObserver('/message/body', self.show_message_body)
        xmlstream.addObserver('/presence[@type="subscribe"]', self.subscribe)
        xmlstream.addObserver('/iq', self.debug)


    def set_status(self, status=None, message=None):
        # Element(namespace, entity)['from'] = attribute
        # set nickname with from <jabber:client:presence from="toto"/>
        presence = domish.Element(('jabber:client', 'presence'))
        presence['from'] = self.jid.full()
        # Entity show for status
        show = domish.Element((None,'show'))

        # set statut 
        if status:
            show.addContent(status)
        else:
            show.addContent(self.status)

        # TODO: check the encoding
        # if message:
            # mess = domish.Element((None, 'status'))
            # mess.addContent(message.encode('utf-8'))
            # presence.addChild(mess)

        presence.addChild(show)
        # send xml stream
        self.xmlstream.send(presence)


    def show_message(self, elem):
        print elem.thread
    

    def show_message_body(self, elem):

        def make_message(text):
            message = domish.Element(('jabber:client', 'message'))
            message['to'] = elem.getAttribute('from')
            message['from'] = self.jid.full()
            message['type'] = 'chat'
            body = domish.Element((None, 'body'))
            body.addContent(text)
            message.addChild(body)
            return message
            

        print elem.body.__str__().encode('utf-8')

        # TODO: IMPORTANT!!! tout le focus ici 

        # if elem.body.__str__() == "coucou":

        #    self.xmlstream.send(make_message("salut"))



    def subscribe(self, elem):

        subscribe = domish.Element((None,'presence'))

        subscribe['to'] = elem.getAttribute('from')

        subscribe['from'] = self.jid.full()
        subscribe['type'] = 'subscribed'
        # nick = domish.Element(('http://jabber.org/protocol/nick', 'nick'))
        # nick.addContent("JabberBot")
        # subscribe.addChild(nick)
        self.xmlstream.send(subscribe)


    def debug(self, elem):
        print elem.toXml().encode('utf-8')
        print "="*50
    

    def run(self):
        factory = client.basicClientFactory(self.jid, self.password)
        factory.addBootstrap('//event/stream/authd', self.authd)
        reactor.connectTCP(self.host, self.port, factory)
        reactor.run()
