#!/usr/bin/python
import socket
import pygtk
pygtk.require('2.0')
import gtk
import gobject
import time
import xml.dom.minidom
import signal
import sys
sys.path.append("common")
import griddata
import gridarea

def signal_handler(signal, frame):
    print "SERVER EXIT"
    gtk.main_quit()

class server:
    def __init__(self):

        signal.signal(signal.SIGINT, signal_handler)

        self.size = 6
        self.ready = 0

        self.grid = griddata.grid(self.size)

        self.host = ""                 # Symbolic name meaning the local host
        self.port1 = 8000              # Arbitrary non-privileged port
        self.port2 = 8001              # Arbitrary non-privileged port
        self.s1 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s2 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        try:
            self.s1.bind((self.host, self.port1))
            self.s2.bind((self.host, self.port2))
        except socket.error:
            print "CAN T BIND SOCKET - SERVER EXIT"
            sys.exit(0)
        self.start()

        gobject.io_add_watch(self.conn1, gobject.IO_IN, self.socket_callback)
        gobject.io_add_watch(self.conn2, gobject.IO_IN, self.socket_callback)

        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("destroy", lambda w: gtk.main_quit())

        self.area = gridarea.area(self.size, self.grid, self)

        #Creation de la VBox
        self.box = gtk.VBox(False, 5)

        #Creation de la frame
        self.frame =  gtk.Frame("Grille")
        self.frame.add(self.area)
        self.box.pack_start(self.frame,True,10)

        self.window.add(self.box)

        #Et hop
        self.window.show_all()
        self.area.setGC() # doit etre appele apres window.show_all

    def start(self):
        self.s1.listen(1)
        self.s2.listen(1)
        self.conn1, addr1 = self.s1.accept()
        self.conn2, addr2 = self.s2.accept()

    def close(self):
        print "Server : closing socket"
        self.s1.close()
        self.s2.close()

    def send_result(self, source, move, out):
        assert out != 0
        if out < 0:
            outStr = "green"
        else:
            outStr = "red"

        if source == self.conn1:
            self.conn1.send("<%s/>" % outStr)
            self.conn2.send("<play number='%s' position='%s' color='%s' outStr='%s'/>" % (move["number"], move["position"].capitalize(), move["color"].capitalize(), outStr.capitalize()))
        else:
            self.conn1.send("<play number='%s' position='%s' color='%s' outStr='%s'/>" % (move["number"], move["position"].capitalize(), move["color"].capitalize(), outStr.capitalize()))
            self.conn2.send("<%s/>" % outStr)

    def send_invalid(self, source):
        self.conn1.send('<invalid/>')
        self.conn2.send('<invalid/>')

    def push(self, move, player, source):
        out = self.grid.push(move, player)
        if out != 0:
            self.send_result(source, move, out)
            return True
        else:
            self.send_invalid(source)
            return False

    def socket_callback(self, source, condition):

        try:
            if source == self.conn1:
                data = "<root>%s</root>" % self.conn1.recv(1024)
            else:
                data = "<root>%s</root>" % self.conn2.recv(1024)
        except socket.error:
                print "Serveur : on a perdu un client !"
                self.close()
                return False

        doc = xml.dom.minidom.parseString(data)
        msg = doc.documentElement.firstChild

        if msg == None:
            return True

        tag = msg.tagName.lower()

        if tag == "start":

            if source == self.conn1:
                self.ready = self.ready + 1
            else:
                self.ready = self.ready + 1

            if (self.ready == 2):
                self.conn1.send("<ready/>")
                self.conn2.send("<ready/>")
                #time.sleep(1)
                self.conn1.send("<go/>")

            return True

        if tag == "play":

            move = {}
            for i in range(0, msg.attributes.length):
                move[msg.attributes.item(i).name] = msg.attributes.item(i).value.lower()

            if source == self.conn1: ## c'est le joueur vert
                player = -2
            else:
                player = 2

            moveIsValid = self.push(move, player, source)

            self.grid.verifie()

            if self.grid.finish(-1): ## le joueur vert a t-il gagne ?
                self.conn1.send('<win/>')
                self.conn2.send('<lose/>')
                #gtk.main_quit()
            else:
                if self.grid.finish(1):  ## le joueur rouge a t-il gagne ?
                    self.conn1.send('<lose/>')
                    self.conn2.send('<win/>')
                    #gtk.main_quit()
                else: ## envoi le message Go au joueur suivant
                    try:
                        if moveIsValid == True: # si le coup est invalid, <go/> sera retourne au meme joueur
                            if source == self.conn1:
                                self.conn2.send('<go/>')
                            else:
                                self.conn1.send('<go/>')
                        else:
                            if source == self.conn1:
                                self.conn1.send('<go/>')
                            else:
                                self.conn2.send('<go/>')
                    except socket.error:
                            print "Serveur : on a perdu un client !"
                            self.close()
                            return False
            self.area.draw(move)
            return True

        return False # client s'est deconnecte, on errete d'ecouter

    def main(self):
        gtk.main()

if __name__=="__main__":
    s = server()
    s.main()
