/*----------------------------------------------------------------------*/
/* Fichier : tpi2ldd1wait.c                                             */
/* Auteur  : D. Duvivier - LIL/ULCO                                     */
/* Date    : 16/09/09                                                   */
/* Objectif: TP N3 M2/I2L Systme Rseaux Scurit                     */
/*           Test des primitives "fork()" et "wait()"                   */
/*----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>

pid_t pid; /* Variable partagee : process identifier du fils ou 0 */

int main(void) {
  puts("Lancement du programme...");
  printf("Le pid du processus est %d et son ppid est %d\n", getpid(), getppid());
  pid = fork();
  if (pid < 0) {
    perror("echec fork");
    exit(EXIT_FAILURE); /* fork() a echoue -> fin du programme */
  }
  else if (pid > 0) {
    /* Variable uniquement accedee par le pere */
    int status; /* Code de retour du processus fils */
    /* Code du pere */
    puts("Code du pre...");
    printf("Le pid du fils est %d et son ppid est %d\n", pid, getppid());
    puts("Le pre se met en attente pour 1 seconde ...");
    sleep(1);
    puts("Le pre attend son processus fils ...");
    wait(&status);
    puts("Fin d'attente du pere...");
    printf("Le code de retour du fils est %d\n", status);
    puts("Fin du processus pere...");
  }
  else {
    /* Code du fils */
    puts("Code du fils...");
    puts("Le fils se met en attente pour 5 secondes ...");
    sleep(5);
    puts("Fin d'attente du fils...");
    /* Arret anticipe du processus fils avec code de retour 0 */
    /* une valeur differente de 0 (EXIT_SUCCESS) indique une erreur */
    /* comme par exemple exit(EXIT_FAILURE); */
    exit(EXIT_SUCCESS);
  }
  /* Seul le pre va passer ici en fin de programme sauf erreur */
  printf("Fin du processus %d\n", getpid());
  return(EXIT_SUCCESS);
}
